Fix warning in test.
[awesomized/libmemcached] / bootstrap.sh
index d822e592a33963d39b25515592c52191bfe7dc97..42c2157b4862a164f18747190400275c4b2757ff 100755 (executable)
@@ -1,6 +1,6 @@
 #!/bin/bash
 # 
-# Copyright (C) 2012 Brian Aker
+# Copyright (C) 2012-2013 Brian Aker
 # All rights reserved.
 # 
 # Redistribution and use in source and binary forms, with or without
 
 command_not_found_handle ()
 {
-  echo "Command not found: '$@'"
-  exit 127
+  warn "$@: command not found"
+
+  #if $DEBUG; then 
+    echo ""
+    echo "Stack trace:"
+    local frame=0
+    while caller $frame; do
+      ((frame++));
+    done
+    echo ""
+  #fi
+
+  return 127
+}
+
+function error ()
+{ 
+  echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
 }
 
 function die ()
@@ -55,6 +71,12 @@ function die ()
   exit 1; 
 }
 
+function warn ()
+{ 
+  echo "$BASH_SOURCE:$BASH_LINENO: $@"
+  #echo "$BASH_SOURCE:$BASH_LINENO: $@" >&1
+}
+
 function nassert ()
 {
   local param_name=\$"$1"
@@ -77,7 +99,7 @@ function assert ()
   fi
 }
 
-assert_file ()
+function assert_file ()
 {
   if [ ! -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
@@ -85,7 +107,7 @@ assert_file ()
   fi
 }
 
-assert_no_file ()
+function assert_no_file ()
 {
   if [ -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) file exists: $2" >&2
@@ -93,7 +115,15 @@ assert_no_file ()
   fi
 }
 
-assert_exec_file ()
+function assert_no_directory ()
+{
+  if [ -d "$1" ]; then
+    echo "$BASH_SOURCE:$BASH_LINENO: assert($1) directory exists: $2" >&2
+    exit 1;
+  fi
+}
+
+function assert_exec_file ()
 {
   if [ ! -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
@@ -106,12 +136,12 @@ assert_exec_file ()
   fi
 }
 
-command_exists ()
+function command_exists ()
 {
   type "$1" &> /dev/null ;
 }
 
-rebuild_host_os ()
+function rebuild_host_os ()
 {
   HOST_OS="${UNAME_MACHINE_ARCH}-${VENDOR}-${VENDOR_DISTRIBUTION}-${VENDOR_RELEASE}-${UNAME_KERNEL}-${UNAME_KERNEL_RELEASE}"
   if [ -z "$1" ]; then
@@ -122,7 +152,7 @@ rebuild_host_os ()
 }
 
 #  Valid values are: darwin,fedora,rhel,ubuntu
-set_VENDOR_DISTRIBUTION ()
+function set_VENDOR_DISTRIBUTION ()
 {
   local dist=`echo "$1" | tr '[A-Z]' '[a-z]'`
   case "$dist" in
@@ -147,7 +177,7 @@ set_VENDOR_DISTRIBUTION ()
   esac
 }
 
-set_VENDOR_RELEASE ()
+function set_VENDOR_RELEASE ()
 {
   local release=`echo "$1" | tr '[A-Z]' '[a-z]'`
   case "$VENDOR_DISTRIBUTION" in
@@ -177,7 +207,7 @@ set_VENDOR_RELEASE ()
 
 
 #  Valid values are: apple, redhat, centos, canonical
-set_VENDOR ()
+function set_VENDOR ()
 {
   local vendor=`echo "$1" | tr '[A-Z]' '[a-z]'`
 
@@ -206,7 +236,7 @@ set_VENDOR ()
   set_VENDOR_RELEASE $3
 }
 
-determine_target_platform ()
+function determine_target_platform ()
 {
   UNAME_MACHINE_ARCH=`(uname -m) 2>/dev/null` || UNAME_MACHINE_ARCH=unknown
   UNAME_KERNEL=`(uname -s) 2>/dev/null`  || UNAME_SYSTEM=unknown
@@ -242,7 +272,7 @@ determine_target_platform ()
   rebuild_host_os
 }
 
-run_configure ()
+function run_configure ()
 {
   # We will run autoreconf if we are required
   run_autoreconf_if_required
@@ -252,6 +282,10 @@ run_configure ()
     die "Programmer error, we entered run_configure with a stacked directory"
   fi
 
+  if ! command_exists "$CONFIGURE"; then
+    die "$CONFIGURE does not exist"
+  fi
+
   local BUILD_DIR="$1"
   if [[ -n "$BUILD_DIR" ]]; then
     rm -r -f $BUILD_DIR
@@ -260,40 +294,52 @@ run_configure ()
   fi
 
   # Arguments for configure
-  local CONFIGURE_ARG= 
+  local BUILD_CONFIGURE_ARG= 
 
-  # Set ENV DEBUG in order to enable debugging
+  # If ENV DEBUG is set we enable both debug and asssert, otherwise we see if this is a VCS checkout and if so enable assert
+  # Set ENV ASSERT in order to enable assert
   if $DEBUG; then 
-    CONFIGURE_ARG='--enable-debug'
+    BUILD_CONFIGURE_ARG+=' --enable-debug --enable-assert'
+  elif [[ -n "$VCS_CHECKOUT" ]]; then
+    BUILD_CONFIGURE_ARG+=' --enable-assert'
   fi
 
-  # Set ENV ASSERT in order to enable assert
-  if [[ -n "$ASSERT" ]]; then 
-    local ASSERT_ARG=
-    ASSERT_ARG='--enable-assert'
-    CONFIGURE_ARG="$ASSERT_ARG $CONFIGURE_ARG"
+  if [[ -n "$CONFIGURE_ARG" ]]; then 
+    BUILD_CONFIGURE_ARG+=" $CONFIGURE_ARG"
+  fi
+
+  if [[ -n "$PREFIX_ARG" ]]; then 
+    BUILD_CONFIGURE_ARG+=" $PREFIX_ARG"
   fi
 
+  ret=1;
   # If we are executing on OSX use CLANG, otherwise only use it if we find it in the ENV
   case $HOST_OS in
     *-darwin-*)
-      CC=clang CXX=clang++ $top_srcdir/configure $CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $CONFIGURE_ARG $PREFIX_ARG"
+      CC=clang CXX=clang++ $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $BUILD_CONFIGURE_ARG"
+      ret=$?
       ;;
     rhel-5*)
-      command_exists gcc44 || die "Could not locate gcc44"
-      CC=gcc44 CXX=gcc44 $top_srcdir/configure $CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $CONFIGURE_ARG $PREFIX_ARG"
+      command_exists 'gcc44' || die "Could not locate gcc44"
+      CC=gcc44 CXX=gcc44 $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $BUILD_CONFIGURE_ARG"
+      ret=$?
       ;;
     *)
-      $top_srcdir/configure $CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute configure $CONFIGURE_ARG $PREFIX_ARG"
+      $CONFIGURE $BUILD_CONFIGURE_ARG
+      ret=$?
       ;;
   esac
 
+  if [ $ret -ne 0 ]; then
+    die "Could not execute $CONFIGURE $BUILD_CONFIGURE_ARG"
+  fi
+
   if [ ! -f 'Makefile' ]; then
-    die "Programmer error, configure was run but no Makefile existed afterward"
+    die "Programmer error, configure was run but no Makefile existed after $CONFIGURE was run"
   fi
 }
 
-setup_gdb_command () {
+function setup_gdb_command () {
   GDB_TMPFILE=$(mktemp /tmp/gdb.XXXXXXXXXX)
   echo 'set logging overwrite on' > $GDB_TMPFILE
   echo 'set logging on' >> $GDB_TMPFILE
@@ -304,62 +350,91 @@ setup_gdb_command () {
   GDB_COMMAND="gdb -f -batch -x $GDB_TMPFILE"
 }
 
-setup_valgrind_command () {
+function setup_valgrind_command () {
   VALGRIND_PROGRAM=`type -p valgrind`
   if [[ -n "$VALGRIND_PROGRAM" ]]; then
     VALGRIND_COMMAND="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --show-reachable=yes --track-fds=yes --malloc-fill=A5 --free-fill=DE"
   fi
 }
 
-push_PREFIX_ARG ()
+function save_BUILD ()
 {
-  if [[ -n "$PREFIX_ARG" ]]; then
-    OLD_PREFIX_ARG=$PREFIX_ARG
-    PREFIX_ARG=
+  if [[ -n "$OLD_CONFIGURE" ]]; then
+    die "OLD_CONFIGURE($OLD_CONFIGURE) was set on push, programmer error!"
   fi
 
-  if [[ -n "$1" ]]; then
-    PREFIX_ARG="--prefix=$1"
+  if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
+    die "OLD_CONFIGURE_ARG($OLD_CONFIGURE_ARG) was set on push, programmer error!"
   fi
-}
 
-pop_PREFIX_ARG ()
-{
-  if [[ -n "$OLD_PREFIX_ARG" ]]; then
-    PREFIX_ARG=$OLD_TESTS_ENVIRONMENT
-    OLD_PREFIX_ARG=
-  else
-    PREFIX_ARG=
+  if [[ -n "$OLD_PREFIX" ]]; then
+    die "OLD_PREFIX($OLD_PREFIX) was set on push, programmer error!"
+  fi
+
+  if [[ -n "$OLD_MAKE" ]]; then
+    die "OLD_MAKE($OLD_MAKE) was set on push, programmer error!"
   fi
-}
 
-push_TESTS_ENVIRONMENT ()
-{
   if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
-    die "OLD_TESTS_ENVIRONMENT was set on push, programmer error!"
+    die "OLD_TESTS_ENVIRONMENT($OLD_TESTS_ENVIRONMENT) was set on push, programmer error!"
+  fi
+
+  if [[ -n "$CONFIGURE" ]]; then
+    OLD_CONFIGURE=$CONFIGURE
+  fi
+
+  if [[ -n "$CONFIGURE_ARG" ]]; then
+    OLD_CONFIGURE_ARG=$CONFIGURE_ARG
+  fi
+
+  if [[ -n "$MAKE" ]]; then
+    OLD_MAKE=$MAKE
   fi
 
   if [[ -n "$TESTS_ENVIRONMENT" ]]; then
     OLD_TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT
-    TESTS_ENVIRONMENT=
   fi
 }
 
-pop_TESTS_ENVIRONMENT ()
+function restore_BUILD ()
 {
-  TESTS_ENVIRONMENT=
+  if [[ -n "$OLD_CONFIGURE" ]]; then
+    CONFIGURE=$OLD_CONFIGURE
+  fi
+
+  if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
+    CONFIGURE_ARG=$OLD_CONFIGURE_ARG
+  fi
+
+  if [[ -n "$OLD_PREFIX" ]]; then
+    PREFIX_ARG=$OLD_PREFIX
+  fi
+
+  if [[ -n "$OLD_MAKE" ]]; then
+    MAKE=$OLD_MAKE
+  fi
+
   if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
     TESTS_ENVIRONMENT=$OLD_TESTS_ENVIRONMENT
-    OLD_TESTS_ENVIRONMENT=
   fi
+
+  OLD_CONFIGURE=
+  OLD_CONFIGURE_ARG=
+  OLD_PREFIX=
+  OLD_MAKE=
+  OLD_TESTS_ENVIRONMENT=
+
+  export -n CC CXX
 }
 
 function safe_pushd ()
 {
   pushd $1 &> /dev/null ;
 
-  if $VERBOSE -a test -n "$BUILD_DIR"; then
-    echo "BUILD_DIR=$BUILD_DIR"
+  if [ -n "$BUILD_DIR" ]; then
+    if $VERBOSE; then
+      echo "BUILD_DIR=$BUILD_DIR"
+    fi
   fi
 }
 
@@ -400,11 +475,11 @@ function make_valgrind ()
     return 1
   fi
 
+  save_BUILD
+
   # If we are required to run configure, do so now
   run_configure_if_required
 
-  push_TESTS_ENVIRONMENT
-
   # If we don't have a configure, then most likely we will be missing libtool
   assert_file 'configure'
   if [[ -f 'libtool' ]]; then
@@ -415,13 +490,15 @@ function make_valgrind ()
 
   make_target 'check' || return 1
 
-  pop_TESTS_ENVIRONMENT
+  restore_BUILD
 }
 
 function make_install_system ()
 {
   local INSTALL_LOCATION=$(mktemp -d /tmp/XXXXXXXXXX)
-  push_PREFIX_ARG $INSTALL_LOCATION
+
+  save_BUILD
+  PREFIX_ARG="--prefix=$INSTALL_LOCATION"
 
   if [ ! -d $INSTALL_LOCATION ] ; then
     die "ASSERT temp directory not found '$INSTALL_LOCATION'"
@@ -429,17 +506,12 @@ function make_install_system ()
 
   run_configure #install_buid_dir
 
-  push_TESTS_ENVIRONMENT
-
   make_target 'install'
 
   make_target 'installcheck'
 
   make_target 'uninstall'
 
-  pop_TESTS_ENVIRONMENT
-  pop_PREFIX_ARG
-
   rm -r -f $INSTALL_LOCATION
   make 'distclean'
 
@@ -447,6 +519,7 @@ function make_install_system ()
     die "ASSERT Makefile should not exist"
   fi
 
+  restore_BUILD
   safe_popd
 }
 
@@ -470,6 +543,10 @@ function make_darwin_malloc ()
 
 function snapshot_check ()
 {
+  if [ ! -f "$BOOTSTRAP_SNAPSHOT_CHECK" ]; then
+    make_for_snapshot
+  fi
+
   if [ -n "$BOOTSTRAP_SNAPSHOT_CHECK" ]; then
     assert_file "$BOOTSTRAP_SNAPSHOT_CHECK" 'snapshot check failed'
   fi
@@ -492,24 +569,166 @@ function make_for_snapshot ()
   snapshot_check
 }
 
-function make_for_mingw32 ()
+function check_mingw ()
+{
+  command_exists 'mingw64-configure'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  command_exists 'mingw64-make'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  return 0
+}
+
+function check_clang ()
+{
+  command_exists 'clang'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  return 0
+}
+
+function check_clang_analyzer ()
+{
+  command_exists 'scan-build'
+  ret=$?
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
+
+  return 0
+}
+
+function make_skeleton ()
+{
+  run_configure
+  ret=$?
+
+  if [ $ret -eq 0 ]; then
+    assert_file 'Makefile'
+
+    make_target 'all' 'warn'
+    ret=$?
+    if [ $ret -ne 0 ]; then
+      warn "$MAKE failed"
+    else
+      if [[ -n "$DISPLAY" ]]; then
+        if command_exists 'wine'; then
+          TESTS_ENVIRONMENT='wine'
+        fi
+      fi
+
+      if [[ -n "$TESTS_ENVIRONMENT" ]]; then
+        make_target 'check' 'warn' || warn "$MAKE check failed"
+        ret=$?
+      fi
+    fi
+
+    if $jenkins_build_environment; then
+      make_target 'clean' 'warn'
+    fi
+  fi
+
+  return $ret
+}
+
+function make_for_mingw ()
 {
+  if ! check_mingw; then
+    return 1
+  fi
+
   # Make sure it is clean
   if [ -f Makefile -o -f configure ]; then
     make_maintainer_clean
   fi
-  assert_no_file 'Makefile'
 
-  if command_exists mingw32-configure; then
-    run_autoreconf
+  run_autoreconf
 
-    mingw32-configure || die 'mingw32-configure failed'
-    assert_file 'Makefile'
+  save_BUILD
 
-    if command_exists mingw32-make; then
-      mingw32-make || die 'mingw32-make failed'
-    fi
+  CONFIGURE='mingw64-configure'
+  MAKE='mingw64-make'
+  CONFIGURE_ARGS='--enable-static --disable-shared'
+
+  make_skeleton
+  ret=$?
+
+  restore_BUILD
+
+  return $ret
+}
+
+function make_for_clang ()
+{
+  if ! check_clang; then
+    return 1
+  fi
+
+  # Make sure it is clean
+  if [ -f Makefile -o -f configure ]; then
+    make_maintainer_clean
   fi
+
+  run_autoreconf
+
+  save_BUILD
+
+  CC=clang CXX=clang++
+  export CC CXX
+
+  make_skeleton
+  ret=$?
+
+  make_target 'check'
+
+  restore_BUILD
+
+  return $ret
+}
+
+function make_for_clang_analyzer ()
+{
+  if ! check_clang; then
+    return 1
+  fi
+
+  if ! check_clang_analyzer; then
+    die 'clang-analyzer was not found'
+  fi
+
+  # Make sure it is clean
+  if [ -f Makefile -o -f configure ]; then
+    make_maintainer_clean
+  fi
+
+  run_autoreconf
+
+  save_BUILD
+
+  CC=clang CXX=clang++
+  export CC CXX
+  CONFIGURE_ARGS='--enable-debug'
+
+  make_skeleton
+  ret=$?
+
+  make_target 'clean' 'warn'
+
+  scan-build -o clang-html make -j4 -k
+
+  restore_BUILD
+
+  return $ret
 }
 
 # If we are locally testing, we should make sure the environment is setup correctly
@@ -534,7 +753,13 @@ function make_universe ()
   make_valgrind
   make_gdb
   make_rpm
-  make_for_mingw32
+  make_for_clang
+  make_for_clang_analyzer
+
+  if [ check_mingw -eq 0 ]; then
+    make_for_mingw
+  fi
+
   make_distcheck
   make_install_system
 }
@@ -567,6 +792,8 @@ function make_for_continuus_integration ()
       assert_exec_file 'configure'
       assert_file 'Makefile'
 
+      make_target 'all'
+
       # make rpm includes "make distcheck"
       if [[ -f rpm.am ]]; then
         make_rpm
@@ -587,6 +814,8 @@ function make_for_continuus_integration ()
       assert_exec_file 'configure'
       assert_file 'Makefile'
 
+      make_target 'all'
+
       make_distcheck
 
       assert_exec_file 'configure'
@@ -621,13 +850,20 @@ function self_test ()
   eval "./bootstrap.sh maintainer-clean" || die "failed 'maintainer-clean'"
 }
 
-function make_gdb ()
+function make_install_html ()
 {
   run_configure_if_required
+  assert_file 'configure'
+
+  make_target 'install-html'
+}
 
-  if command_exists gdb; then
+function make_gdb ()
+{
+  save_BUILD
 
-    push_TESTS_ENVIRONMENT
+  if command_exists 'gdb'; then
+    run_configure_if_required
 
     # Set ENV GDB_COMMAND
     if [[ -z "$GDB_COMMAND" ]]; then
@@ -642,28 +878,32 @@ function make_gdb ()
       TESTS_ENVIRONMENT="$GDB_COMMAND"
     fi
 
-    make_target check
+    make_target 'check'
 
     if [ -f 'gdb.txt' ]; then
       rm 'gdb.txt'
     fi
 
-    pop_TESTS_ENVIRONMENT
-
     if [ -f '.gdb_history' ]; then
       rm '.gdb_history'
     fi
+
+    if $jenkins_build_environment; then
+      make_target 'clean'
+    fi
   else
     echo 'gdb was not present'
     return 1
   fi
+
+  restore_BUILD
 }
 
 # $1 target to compile
 # $2 to die, or not to die, based on contents
 function make_target ()
 {
-  if [[ -z "$1" ]]; then
+  if [ -z "$1" ]; then
     die "Programmer error, no target provided for make"
   fi
 
@@ -672,19 +912,29 @@ function make_target ()
     run_configure
   fi
 
-  if [ -n "$TESTS_ENVIRONMENT" -a $VERBOSE ]; then
-    echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
+  if [ -n "$TESTS_ENVIRONMENT" ]; then
+    if $VERBOSE; then
+      echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
+    fi
   fi
 
-  if [[ -z "$MAKE" ]]; then
+  if [ -z "$MAKE" ]; then
     die "MAKE was not set"
   fi
 
-  if [[ -n "$2" ]]; then
-    run $MAKE $1 || return 1
-  else
-    run $MAKE $1 || die "Cannot execute $MAKE $1"
+  # $2 represents error or warn
+  run $MAKE $1
+  ret=$?
+
+  if [ $ret -ne 0 ]; then
+    if [ -n "$2" ]; then
+      warn "Failed to execute $MAKE $1: $ret"
+    else
+      die "Failed to execute $MAKE $1: $ret"
+    fi
   fi
+
+  return $ret
 }
 
 function make_distcheck ()
@@ -694,9 +944,16 @@ function make_distcheck ()
 
 function make_rpm ()
 {
-  if [ -f 'rpm.am' -o -d 'rpm' ]; then
-    run_configure_if_required
-    make_target 'rpm'
+  if command_exists 'rpmbuild'; then
+    if [ -f 'rpm.am' -o -d 'rpm' ]; then
+      run_configure_if_required
+      make_target 'rpm'
+
+      if $jenkins_build_environment; then
+        make_target 'clean'
+      fi
+
+    fi
   fi
 }
 
@@ -704,6 +961,11 @@ function make_maintainer_clean ()
 {
   run_configure_if_required
   make_target 'maintainer-clean' 'no_error'
+
+  # Lets make sure we really cleaned up the environment
+  assert_no_file 'Makefile'
+  assert_no_file 'configure'
+  assert_no_directory 'autom4te.cache'
 }
 
 function make_check ()
@@ -749,6 +1011,11 @@ function run_autoreconf ()
     die "Programmer error, tried to call run_autoreconf () but AUTORECONF was not set"
   fi
 
+  if test $use_libtool = 1; then
+    assert $BOOTSTRAP_LIBTOOLIZE
+    run $BOOTSTRAP_LIBTOOLIZE '--copy' '--install' '--force' || die "Cannot execute $BOOTSTRAP_LIBTOOLIZE"
+  fi
+
   run $AUTORECONF || die "Cannot execute $AUTORECONF"
 
   eval 'bash -n configure' || die "autoreconf generated a malformed configure"
@@ -760,10 +1027,14 @@ function run ()
     echo "\`$@' $ARGS"
   fi
 
+  if [ -z "$1" ]; then
+    return 127;
+  fi
+
   eval $@ $ARGS
 } 
 
-parse_command_line_options ()
+function parse_command_line_options ()
 {
   local SHORTOPTS=':apcmt:dvh'
 
@@ -821,7 +1092,7 @@ parse_command_line_options ()
   fi
 }
 
-determine_vcs ()
+function determine_vcs ()
 {
   if [[ -d '.git' ]]; then
     VCS_CHECKOUT=git
@@ -831,6 +1102,8 @@ determine_vcs ()
     VCS_CHECKOUT=svn
   elif [[ -d '.hg' ]]; then
     VCS_CHECKOUT=hg
+  else
+    VCS_CHECKOUT=
   fi
 
   if [[ -n "$VCS_CHECKOUT" ]]; then
@@ -838,14 +1111,23 @@ determine_vcs ()
   fi
 }
 
-autoreconf_setup ()
+function require_libtoolise ()
+{
+  use_libtool=0
+  grep '^[         ]*A[CM]_PROG_LIBTOOL' configure.ac >/dev/null \
+    && use_libtool=1
+  grep '^[         ]*LT_INIT' configure.ac >/dev/null \
+    && use_libtool=1
+}
+
+function autoreconf_setup ()
 {
   # Set ENV MAKE in order to override "make"
   if [[ -z "$MAKE" ]]; then 
-    if command_exists gmake; then
+    if command_exists 'gmake'; then
       MAKE=`type -p gmake`
     else
-      if command_exists make; then
+      if command_exists 'make'; then
         MAKE=`type -p make`
       fi
     fi
@@ -881,15 +1163,36 @@ autoreconf_setup ()
     fi
   fi
 
-  if [[ -z "$LIBTOOLIZE" ]]; then
-    # If we are using OSX, we first check to see glibtoolize is available
-    if [[ "$VENDOR_DISTRIBUTION" == "darwin" ]]; then
-      LIBTOOLIZE=`type -p glibtoolize`
+  if test $use_libtool = 1; then
+    if [[ -n "$LIBTOOLIZE" ]]; then
+      BOOTSTRAP_LIBTOOLIZE=`type -p $LIBTOOLIZE`
 
-      if [[ -z "$LIBTOOLIZE" ]]; then
-        echo "Couldn't find glibtoolize, it is required on OSX"
+      if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
+        echo "Couldn't find user supplied libtoolize, it is required"
       fi
+    else
+      # If we are using OSX, we first check to see glibtoolize is available
+      if [[ "$VENDOR_DISTRIBUTION" == "darwin" ]]; then
+        BOOTSTRAP_LIBTOOLIZE=`type -p glibtoolize`
+
+        if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
+          echo "Couldn't find glibtoolize, it is required on OSX"
+        fi
+      else
+        BOOTSTRAP_LIBTOOLIZE=`type -p libtoolize`
+
+        if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
+          echo "Couldn't find libtoolize, it is required"
+        fi
+      fi
+    fi
+    if $VERBOSE; then
+      LIBTOOLIZE_OPTIONS="--verbose $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
     fi
+    if $DEBUG; then
+      LIBTOOLIZE_OPTIONS="--debug $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
+    fi
+    LIBTOOLIZE=true
   fi
 
   # Test the ENV AUTOMAKE if it exists
@@ -912,6 +1215,12 @@ autoreconf_setup ()
     run $AUTOM4TE '--help'    &> /dev/null    || die "Failed to run AUTOM4TE:$AUTOM4TE"
   fi
 
+  # Test the ENV AUTOHEADER if it exists, if not we add one and add --install
+  if [[ -z "$ACLOCAL" ]]; then
+    ACLOCAL="aclocal --install"
+  fi
+  run $ACLOCAL '--help'  &> /dev/null    || die "Failed to run ACLOCAL:$ACLOCAL"
+
   if [[ -z "$AUTORECONF" ]]; then
     AUTORECONF=`type -p autoreconf`
 
@@ -927,7 +1236,7 @@ autoreconf_setup ()
   run $AUTORECONF '--help'  &> /dev/null    || die "Failed to run AUTORECONF:$AUTORECONF"
 }
 
-print_setup ()
+function print_setup ()
 {
   saved_debug_status=$DEBUG
   if $DEBUG; then
@@ -1006,7 +1315,7 @@ print_setup ()
   fi
 }
 
-make_clean_option ()
+function make_clean_option ()
 {
   run_configure_if_required
 
@@ -1019,7 +1328,7 @@ make_clean_option ()
   fi
 }
 
-make_for_autoreconf ()
+function make_for_autoreconf ()
 {
   if [ -f 'Makefile' ]; then
     make_maintainer_clean
@@ -1030,11 +1339,13 @@ make_for_autoreconf ()
   assert_no_file 'Makefile'
 }
 
-check_make_target()
+function check_make_target()
 {
   case $1 in
     'self')
       ;;
+    'rpm')
+      ;;
     'gdb')
       ;;
     'clean_op')
@@ -1067,6 +1378,12 @@ check_make_target()
       ;;
     'all')
       ;;
+    'make_default')
+      ;;
+    'clang')
+      ;;
+    'clang-analyzer')
+      ;;
     'test-*')
       ;;
     'valgrind-*')
@@ -1088,6 +1405,7 @@ function bootstrap ()
   determine_vcs
 
   # Set up whatever we need to do to use autoreconf later
+  require_libtoolise
   autoreconf_setup
 
   if [ -z "$MAKE_TARGET" ]; then
@@ -1110,7 +1428,7 @@ function bootstrap ()
 
   # Set ENV PREFIX in order to set --prefix for ./configure
   if [[ -n "$PREFIX" ]]; then 
-    push_PREFIX_ARG $PREFIX
+    PREFIX_ARG="--prefix=$PREFIX"
   fi
 
   # We should always have a target by this point
@@ -1132,6 +1450,9 @@ function bootstrap ()
       'gdb')
         make_gdb
         ;;
+      'install-html')
+        make_install_html
+        ;;
       'clean_op')
         make_clean_option
         ;;
@@ -1144,12 +1465,38 @@ function bootstrap ()
       'configure')
         run_configure
         ;;
-      'default')
-        make
-        run_configure
+      'make_default')
+        make_default
+        ;;
+      'clang')
+        if ! check_clang; then
+          die "clang was not found"
+        fi
+
+        if ! make_for_clang; then
+          die "Failed to build clang: $?"
+        fi
+        ;;
+      'clang-analyzer')
+        if ! check_clang_analyzer; then
+          die "clang-analyzer was not found"
+        fi
+        if ! check_clang; then
+          die "clang was not found"
+        fi
+
+        if ! make_for_clang_analyzer; then
+          die "Failed to build clang-analyzer: $?"
+        fi
         ;;
       'mingw')
-        make_for_mingw32
+        if ! check_mingw; then
+          die "mingw was not found"
+        fi
+
+        if ! make_for_mingw; then
+          die "Failed to build mingw: $?"
+        fi
         ;;
       'snapshot')
         make_for_snapshot
@@ -1174,13 +1521,14 @@ function bootstrap ()
   done
 }
 
-main ()
+function main ()
 {
   # Variables we export
   declare -x VCS_CHECKOUT=
 
   # Variables we control globally
   local MAKE_TARGET=
+  local CONFIGURE=
 
   # Options for getopt
   local AUTORECONF_OPTION=false
@@ -1192,12 +1540,24 @@ main ()
   local TARGET_OPTION_ARG=
   local VERBOSE_OPTION=false
 
+  local OLD_CONFIGURE=
+  local OLD_CONFIGURE_ARG=
+  local OLD_PREFIX=
+  local OLD_MAKE=
+  local OLD_TESTS_ENVIRONMENT=
+
   # If we call autoreconf on the platform or not
   local AUTORECONF_REBUILD_HOST=false
   local AUTORECONF_REBUILD=false
 
   local -r top_srcdir=`pwd`
 
+  # Default configure
+  if [ -z "$CONFIGURE" ]; then
+    CONFIGURE="$top_srcdir/configure"
+  fi
+
+
   # Variables for determine_target_platform () and rebuild_host_os ()
   #   UNAME_MACHINE_ARCH= uname -m
   #   VENDOR= apple, redhat, centos, canonical
@@ -1224,8 +1584,10 @@ main ()
   # If we are running under Jenkins we predetermine what tests we will run against
   # This MAKE_TARGET can be overridden by parse_command_line_options based MAKE_TARGET changes.
   # We don't want Jenkins overriding other variables, so we NULL them.
-  if [ -z "$MAKE_TARGET" -a $jenkins_build_environment ]; then
-    MAKE_TARGET='jenkins'
+  if [ -z "$MAKE_TARGET" ]; then
+    if $jenkins_build_environment; then
+      MAKE_TARGET='jenkins'
+    fi
   fi
 
   bootstrap
@@ -1236,7 +1598,49 @@ main ()
   exit 0
 }
 
-enable_debug ()
+function set_branch ()
+{
+  if [ -z "$BRANCH" ]; then 
+    if [ -z "$CI_PROJECT_TEAM" ]; then 
+      die "Variable CI_PROJECT_TEAM has not been set"
+    fi
+    if [ -z "$PROJECT" ]; then 
+      die "Variable PROJECT has not been set"
+    fi
+    if [ -z "$BUILD_TAG" ]; then 
+      die "Variable BUILD_TAG has not been set"
+    fi
+
+    BRANCH="lp:~$CI_PROJECT_TEAM/$PROJECT/$BUILD_TAG"
+    export BRANCH
+  fi
+
+  if [ -z "$BRANCH" ]; then 
+    die "Missing values required to build BRANCH variable."
+  fi
+}
+
+function merge ()
+{
+  if [ -z "$VCS_CHECKOUT" ]; then
+    die "Merges require VCS_CHECKOUT."
+  fi
+
+  set_branch
+
+  if [[ "$VCS_CHECKOUT" == 'bzr' ]]; then
+    if test -n "$BRANCH_TO_MERGE"; then
+      bzr merge $BRANCH_TO_MERGE
+      bzr commit --message="Merge $BRANCH_TO_MERGE Build: $BUILD_TAG" --unchanged
+    fi
+
+    bzr push "$BRANCH"
+  elif [[ -n "$VCS_CHECKOUT" ]]; then
+    die "Merge attempt occured, current VCS setup does not support this"
+  fi
+}
+
+function enable_debug ()
 {
   if ! $DEBUG; then
     local caller_loc=`caller`
@@ -1250,7 +1654,19 @@ enable_debug ()
   fi
 }
 
-disable_debug ()
+function usage ()
+{
+  cat << EOF
+  Usage: $program_name [OPTION]..
+
+  Bootstrap this package from the checked-out sources, and optionally walk through CI run.
+
+  Options:
+
+EOF
+}
+
+function disable_debug ()
 {
   set +x
   DEBUG=true
@@ -1258,6 +1674,8 @@ disable_debug ()
 
 # Script begins here
 
+program_name=$0
+
 env_debug_enabled=false
 if [[ -n "$JENKINS_HOME" ]]; then 
   declare -r jenkins_build_environment=true
@@ -1265,14 +1683,19 @@ else
   declare -r jenkins_build_environment=false
 fi
 
+export ACLOCAL
 export AUTOCONF
 export AUTOHEADER
 export AUTOM4TE
 export AUTOMAKE
 export AUTORECONF
+export CONFIGURE_ARG
 export DEBUG
 export GNU_BUILD_FLAGS
+export LIBTOOLIZE
+export LIBTOOLIZE_OPTIONS
 export MAKE
+export PREFIX_ARG
 export TESTS_ENVIRONMENT
 export VERBOSE
 export WARNINGS